/*
	Packet Radio Telnet
    Version 1.0

	Copyright (C) 1997~1999 Marco Savegnago All rights reserved.	
	
	This software and all its components may be freely distributed and used, except
	in a business, commercial, government, or institutional environment.
	It may not under any circumstances be sold by anyone other than the author.
	It may be distributed by a commercial company as long as it is
	for no cost.
	No resposability can be charged to the author if the program running hang the		
	computer with a consequent loss of data.
	If you find it useful a free contribution if always accepted!    
*/
//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdlib.h>
#include "connectDlg.h"
#include "About.h"
#include "PkTelMain.h"
#include "PkTelStrs.h"
#include "olssm.h"

//---------------------------------------------------------------------
#pragma resource "*.dfm"
TPkTelAppForm *PkTelAppForm;

//---------------------------------------------------------------------
#if __BORLANDC__ >= 0x540
template TOpenOptions;
#else
template class TOpenOptions;
#endif

//---------------------------------------------------------------------
__fastcall TPkTelAppForm::TPkTelAppForm(TComponent *Owner)
:
    TForm(Owner),
    IsServer(false),
    InputLine(2048),
    b_lastline(false)
{
}
//---------------------------------------------------------------------
void __fastcall TPkTelAppForm::FormCreate(TObject *Sender)
{
	SendPane->Lines->Clear();
	ReceivePane->Lines->Clear();
	FileListenItemClick(NULL);
	Application->OnHint     = ShowHint;
}
//---------------------------------------------------------------------
void __fastcall TPkTelAppForm::FileExit(TObject *Sender)
{
	ServerSocket->Close();
	ClientSocket->Close();
	Close();
}
//---------------------------------------------------------------------
void __fastcall TPkTelAppForm::About(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------
void __fastcall TPkTelAppForm::ShowHint(TObject *Sender)
{
	StatusBar->SimpleText = Application->Hint;
}
//---------------------------------------------------------------------

void __fastcall TPkTelAppForm::ClientSocketDisconnect(TObject *Sender, TCustomWinSocket *Socket)
{
	FileListenItemClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ClientSocketConnecting(TObject *Sender, TCustomWinSocket *Socket)
{
    StatusBar->Panels->Items[0]->Text = "Connecteting to: " + sc_ConnectingToHost + " on port: " + sc_ConnectingToPort;
}
//---------------------------------------------------------------------------


void __fastcall TPkTelAppForm::ClientSocketConnect(TObject *Sender, TCustomWinSocket *Socket)
{
	SendPane->Lines->Clear();
    StatusBar->Panels->Items[0]->Text = "Connected to: " + Socket->RemoteAddress;
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::SendPaneKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (Key == VK_RETURN)
    {
        String theLine =   SendPane->Lines->Strings[SendPane->Lines->Count-1];

        theLine += "\r\n";

		if (IsServer)
			ServerSocket->Socket->Connections[0]->SendText(theLine);
		else
			ClientSocket->Socket->SendText(theLine);
	}
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::FileListenItemClick(TObject *Sender)
{
	FileListenItem->Checked = !FileListenItem->Checked;

	if (FileListenItem->Checked)
    {
		ClientSocket->Close();
		ServerSocket->Open();
		StatusBar->Panels->Items[0]->Text = "Listening...";
	}
    else
    {
		if (ServerSocket->Active)
			ServerSocket->Close();

		StatusBar->Panels->Items[0]->Text = "";
	}
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::FileConnectItemClick(TObject *Sender)
{
	if (ClientSocket->Active)
        ClientSocket->Close();

    if(TOKRightDlg* dialog = new TOKRightDlg(this))
    {
        dialog->RemoteAddress->Text=sc_DefaultHost;
        dialog->RemotePort->Text=sc_DefaultPort;

        if(mrOk == dialog->ShowModal())
        {
            ClientSocket->Host=dialog->RemoteAddress->Text;
            sc_ConnectingToHost=dialog->RemoteAddress->Text;
            ClientSocket->Port=dialog->RemotePort->Text.ToInt();
            sc_ConnectingToPort=dialog->RemotePort->Text;

            ClientSocket->Open();
        }

        delete  dialog;
    }
}
//---------------------------------------------------------------------------


void __fastcall TPkTelAppForm::ServerSocketClientDisconnect(TObject *Sender, TCustomWinSocket *Socket)
{
	FileListenItem->Checked = !FileListenItem->Checked;
	FileListenItemClick(NULL);
}

//---------------------------------------------------------------------------

char* TPkTelAppForm::ParseIAC(char* pszBuffer, char* pszBufferEnd)
{
    if (pszBuffer + 2 < pszBufferEnd)
    {
   	    switch (pszBuffer[1])
        {
      	    case 253:
            {
         	    //char szResponse[8];
				//sprintf(szResponse, "%c%c%c", 255, 252, pszBuffer[2]);
        		//NetWriteString(szResponse, 3);
		  	}
		  	case 251:
		  	case 252:
		  	case 254:
				if (pszBuffer + 3 < pszBufferEnd)
				pszBuffer += 3;
				break;

		  	default:
				pszBuffer += 2;
				break;
        }
   }

   return pszBuffer;
}

//---------------------------------------------------------------------------

char* TPkTelAppForm::ParseEscapeANSI(char* pszBuffer, char* pszBufferEnd)
{
	int bExtMode = 0;

	const int nParam = 10;	// Maximum number of parameters
	int iParam[nParam] = {0, 0, 0, 0, 0};
	int iCurrentParam = 0;

	// Get parameters from escape sequence.
	while (!isalpha(*pszBuffer))
    {
		// Check for parameter delimiter.
		if (*pszBuffer == ';')
        {
			pszBuffer++;
			continue;
		}

		if (*pszBuffer == '?')
        {
			bExtMode = 1;
			pszBuffer++;
			continue;
		}

		// pszHead should point to digit now. Otherwise we got bad escape
		// sequence, so we just get out of here!
		if (!isdigit(*pszBuffer))
			return pszBuffer;

		iParam[iCurrentParam] = strtoul(pszBuffer, &pszBuffer, 10);

		if (iCurrentParam < nParam)
			iCurrentParam++;
	}

	switch (*pszBuffer++)
    {
	  	// Set cursor position.
		case 'H':
	  	case 'f':
			if (iCurrentParam < 2)
				iParam[1] = 1;
			if (iCurrentParam < 1)
				iParam[0] = 1;

			//ConSetCursorPosition(iParam[1] - 1,	iParam[0] - 1);
			break;

	  	// Move cursor up.
	  	case 'A':
			if (iCurrentParam < 1)
				iParam[0] = 1;

			//ConMoveCursorPosition(0, -iParam[0]);
			break;

	  	// Move cursor down.
	  	case 'B':
			if (iCurrentParam < 1)
				iParam[0] = 1;

			//ConMoveCursorPosition(0, iParam[0]);
			break;

	  	// Move cursor right.
	  	case 'C':
			if (iCurrentParam < 1)
				iParam[0] = 1;

			//ConMoveCursorPosition(-iParam[0], 0);
			break;

	  	// Move cursor left.
	  	case 'D':
			if (iCurrentParam < 1)
				iParam[0] = 1;
			//ConMoveCursorPosition(iParam[0], 0);
			break;

	  	case 'J': 	// Clear screen
        {

			if (iCurrentParam < 1)
				iParam[0] = 2;

			switch (iParam[0])
            {
		  		case 0:
					//ConClearEOScreen();
					break;
		  		case 1:
					//ConClearBOScreen();
					break;
		  		case 2:
					//ConClearScreen();
					break;
			}
			break;
	  	}

	  	case 'K':		// Clear line
     	{
			if (iCurrentParam < 1)
				iParam[0] = 2;

			switch (iParam[0])
            {
		  		case 0:
					//ConClearEOLine();
					break;
		  		case 1:
					//ConClearBOLine();
					break;
		  		case 2:
					//ConClearLine();
					break;
            }
			break;

	  		case 'c':
            {
				//char* szTerminalId = GetTerminalId();
				//NetWriteString(szTerminalId, strlen(szTerminalId));
				break;
	  		}

	  		case 'h':
            {
				if (bExtMode)
                {
					for (int i = 0; i < iCurrentParam; i++)
                    {
						//ConSetExtendedMode(iParam[i], 1);
                    }
                }
				break;
	  		}

	  		case 'l':
            {
				if (bExtMode)
                {
					for (int i = 0; i < iCurrentParam; i++)
                    {
						//ConSetExtendedMode(iParam[i], 0);
                    }
                }
				break;
	  		}
		}
   }

   return pszBuffer;
}


char* TPkTelAppForm::ParseEscape(char* pszBuffer, char* pszBufferEnd)
{
/*	ConWriteString("\033", 1);
	return ++pszBuffer; //*/

	// Check if we have enough characters in buffer.
	if ((pszBufferEnd - pszBuffer) < 2)
		return pszBuffer;

	// Decode the command...
	pszBuffer++;
	switch (*pszBuffer++)
    {
   	    case '[':
        {
            // Check if we have whole escape sequence in buffer.
            char* pszChar = pszBuffer + 1;

            while ((pszChar < pszBufferEnd) && (!isalpha(*pszChar)))
                pszChar++;

            if (pszChar == pszBufferEnd)
                pszBuffer -= 2;
            else
                pszBuffer = ParseEscapeANSI(pszBuffer, pszBufferEnd);
      	    break;
        }

	  	case ')':
			pszBuffer++;
			break;

	  	case 'Z':
     	{
			//char* szTerminalId = GetTerminalId();
			//NetWriteString(szTerminalId, strlen(szTerminalId));
			break;
	  	}
   }

	return pszBuffer;
}

void __fastcall TPkTelAppForm::ClientSocketRead(TObject *Sender, TCustomWinSocket *Socket)
{
    char        buffer[2048];
    int         recvRead;

    while((recvRead  =   Socket->ReceiveBuf(buffer, sizeof(buffer)))>0)
    {
        buffer[recvRead] = 0;

        char*   pszBufferEnd    =   &buffer[recvRead];
        char*   p_buffer        =   &buffer[0];
        char*   p_line          =   &buffer[0];
        bool    b_foundlf       =   false;
        bool    b_foundcr       =   false;

        while(p_buffer < pszBufferEnd)
        {
            switch (*p_buffer)
            {
                case '\n':
                    p_buffer++;
                    b_foundlf   =   true;
                    break;

                case '\r':
                    p_buffer++;
                    b_foundcr   =   true;
                    break;

                case 12:
                    p_buffer++;
                    ReceivePane->Clear();
                    break;

                case 27:
                    p_buffer = ParseEscape(p_buffer, pszBufferEnd);
                    break;

                case 255:
                    p_buffer = ParseIAC(p_buffer, pszBufferEnd);
                    break;

                default:
                    p_buffer++;
                    break;
            }

            if(b_foundlf && b_foundcr)
            {
                b_foundlf       =   false;
                b_foundcr       =   false;

                String  line(p_line, int(p_buffer - p_line)-2);

                if(b_lastline)
                {
                    b_lastline=false;

                    AnsiString  last=ReceivePane->Lines->Strings[ReceivePane->Lines->Count-1];

                    line    =   last + line;

                    ReceivePane->Lines->Delete(ReceivePane->Lines->Count-1);
                }

                if(ReceivePane->Lines->Count>200)
                {
                    ReceivePane->Lines->Delete(0);
                }

                ReceivePane->Lines->Add(line);

                p_line          =   p_buffer;
            }
        }

        if(int(p_buffer - p_line) > 0)
        {
            String  line(p_line, int(p_buffer - p_line));

            if(b_lastline)
            {
                b_lastline=false;

                AnsiString  last=ReceivePane->Lines->Strings[ReceivePane->Lines->Count-1];

                line    =   last + line;

                ReceivePane->Lines->Delete(ReceivePane->Lines->Count-1);
            }

            if(ReceivePane->Lines->Count>200)
            {
                ReceivePane->Lines->Delete(0);
            }

            ReceivePane->Lines->Add(line);

            b_lastline=true;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ServerSocketClientRead(TObject *Sender, TCustomWinSocket *Socket)
{
    ReceivePane->Lines->Add(Socket->ReceiveText());
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ServerSocketAccept(TObject *Sender, TCustomWinSocket *Socket)
{
	IsServer = true;
	StatusBar->Panels->Items[0]->Text = "Connected to: " + Socket->RemoteAddress;
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ServerSocketClientConnect(TObject *Sender, TCustomWinSocket *Socket)
{
	SendPane->Lines->Clear();
	ReceivePane->Lines->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ClientSocketError(TObject *Sender, TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
    String  MsgError    =   "Error connecting to: " + sc_ConnectingToHost + " on port: " + sc_ConnectingToPort;

    MessageBox(0, MsgError.c_str(), "Error", MB_OK);

    StatusBar->Panels->Items[0]->Text = "";

	ErrorCode = 0;
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::FileDisconnectItemClick(TObject *Sender)
{
	if(IsServer)
    {
        IsServer=false;
        ServerSocket->Close();
    }
    else
        ClientSocket->Close();
}
//---------------------------------------------------------------------------


void __fastcall TPkTelAppForm::OnClick(TObject *Sender)
{
    SendPane->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ReceivePaneMouseMove(TObject *Sender,TShiftState Shift, int X, int Y)
{
    SendPane->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ReceivePaneKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
    SendPane->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ReceivePaneMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    SendPane->SetFocus();
}

//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::AboutSpeedButtonClick(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::PasswordsClick(TObject *Sender)
{
    OLSSMEditClientPasswordsDlg((HWND)Handle);
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::SendAuthenticationPasswordClick(TObject *Sender)
{
    char		szReply[256]        =   "";
    char		szChallenge[256] 	= 	"";
    AnsiString  s;

    int  lines   =   ReceivePane->Lines->Count;

    while(lines--)
	{
        int		    index = -1;
        int		    pline =	lines;

        s = ReceivePane->Lines->Strings[lines];

        if(*s.c_str())
        {
            if(OLSSMSearchClientPasswordChallenge(s.c_str(), &index))
            {
               if(OLSSMIsoltateClientPasswordChallange(s.c_str(), szChallenge,	sizeof(szChallenge), index, &pline))
               {
                    if(pline!=lines)
                    {
                        s = ReceivePane->Lines->Strings[pline];
                        strcpy(szChallenge,s.c_str());
                    }

                    if(OLSSMMakeClientPasswordReply(szChallenge, szReply, sizeof(szReply), index))
                    {
                        SendPane->Lines->Add(AnsiString("\n"));
                        SendPane->SetTextBuf(szReply);
                        return;
                    }

                    break;
                }
            }
        }

        lines--;
    }

    MessageBox(0, "Challenge not found or not match!", "SendPass Error!", MB_OK);
}

//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::ManagePasswordSpeedButtonClick(TObject *Sender)
{
    OLSSMEditClientPasswordsDlg((HWND)Handle);
}
//---------------------------------------------------------------------------

void __fastcall TPkTelAppForm::OnActivate(TObject *Sender)
{
    if(!sc_DefaultHost.IsEmpty())
    {
        ClientSocket->Host=sc_DefaultHost;
        sc_ConnectingToHost=sc_DefaultHost;
        ClientSocket->Port=sc_DefaultPort.ToInt();
        sc_ConnectingToPort=sc_DefaultPort;

        ClientSocket->Open();
    }
}
//---------------------------------------------------------------------------

