/*
	Packet Radio Telnet
    Version 1.0

	Copyright (C) 1997~1999 Marco Savegnago All rights reserved.	
	
	This software and all its components may be freely distributed and used, except
	in a business, commercial, government, or institutional environment.
	It may not under any circumstances be sold by anyone other than the author.
	It may be distributed by a commercial company as long as it is
	for no cost.
	No resposability can be charged to the author if the program running hang the		
	computer with a consequent loss of data.
	If you find it useful a free contribution if always accepted!    
*/
//----------------------------------------------------------------------------
#ifndef LogoMainH
#define LogoMainH
//----------------------------------------------------------------------------
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <ScktComp.hpp>

#include "queue.h"
#include <ToolWin.hpp>

typedef TQueue<char>    TLineQueue;

extern  String sc_DefaultHost;
extern  String sc_DefaultPort;

//----------------------------------------------------------------------------

class TPkTelAppForm
:
    public TForm
{
__published:
    TMainMenu *TelnetMenu;
	TMenuItem *FileMenu;
    TMenuItem *FileConnectItem;
	TMenuItem *FileExitItem;
    TMenuItem *Help;
	TMenuItem *AboutItem;
	TStatusBar *StatusBar;
    TSplitter *LowerSplitter;
    TClientSocket *ClientSocket;
    TMemo *SendPane;
    TServerSocket *ServerSocket;
    TMenuItem *FileListenItem;
    TMenuItem *FileDisconnectItem;
    TMemo *ReceivePane;
    TCoolBar *CoolBar;
    TSpeedButton *ConnectSpeedButton;
    TSpeedButton *DisconnectSpeedButton;
    TSpeedButton *ExitSpeedButton;
    TSpeedButton *AboutSpeedButton;
    TMenuItem *Edit;
    TMenuItem *Options;
    TMenuItem *Passwords;
    TSpeedButton *SendPasswordSpeedButton;
    TSpeedButton *ManagePasswordSpeedButton;
    TMenuItem *SendAuthenticationPassword;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FileExit(TObject *Sender);
	void __fastcall About(TObject *Sender);
	void __fastcall ShowHint(TObject *Sender);

    void __fastcall ClientSocketDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ClientSocketConnecting(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ClientSocketConnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall SendPaneKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FileListenItemClick(TObject *Sender);
    void __fastcall FileConnectItemClick(TObject *Sender);
    void __fastcall ServerSocketClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ServerSocketClientRead(TObject *Sender,
          TCustomWinSocket *Socket);


    void __fastcall ServerSocketAccept(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ServerSocketClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ClientSocketError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
    void __fastcall FileDisconnectItemClick(TObject *Sender);


    void __fastcall ClientSocketRead(TObject *Sender,
          TCustomWinSocket *Socket);
    
    void __fastcall OnClick(TObject *Sender);
    void __fastcall ReceivePaneMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    void __fastcall ReceivePaneKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ReceivePaneMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall AboutSpeedButtonClick(TObject *Sender);
    void __fastcall PasswordsClick(TObject *Sender);
    
    
    
    void __fastcall SendAuthenticationPasswordClick(TObject *Sender);
    void __fastcall ManagePasswordSpeedButtonClick(TObject *Sender);
    void __fastcall OnActivate(TObject *Sender);
private:
    bool            IsServer;
    char*           ParseEscape(char* pszBuffer, char* pszBufferEnd);
    char*           ParseEscapeANSI(char* pszBuffer, char* pszBufferEnd);
    char*           ParseIAC(char* pszBuffer, char* pszBufferEnd);

    TLineQueue      InputLine;
    bool            b_lastline;
    String          sc_ConnectingToHost;
    String          sc_ConnectingToPort;


public:
	virtual __fastcall TPkTelAppForm(TComponent *Owner);
};
//----------------------------------------------------------------------------
extern TPkTelAppForm *PkTelAppForm;

//----------------------------------------------------------------------------
#endif
